Subject: Re: linux-next: Tree for Dec 6 (objtool, lots in btrfs)

From: Josh Poimboeuf <[email-masked]>
Date: Fri, 17 Jan 2020 11:26:29 -0600

On Tue, Dec 17, 2019 at 04:25:11PM +0100, David Sterba wrote:
> On Fri, Dec 13, 2019 at 11:05:18PM -0800, Randy Dunlap wrote:
> > OK, that fixes most of them, but still leaves these 2:
> > 
> > btrfs006.out:fs/btrfs/extent_io.o: warning: objtool: __set_extent_bit()+0x536: unreachable instruction
> 
> Hard to read from the assembly what C statement is it referring to. I
> think there are also several functions inlined, I don't see anything
> suspicious inside __set_extent_bit itself.
> 
> > btrfs006.out:fs/btrfs/relocation.o: warning: objtool: add_tree_block()+0x501: unreachable instruction
> 
> Probably also heavily inlined, the function has like 50 lines, a few
> non-trivial function calls but the offset in the warning suggests a
> larger size.
> 
> While browsing the callees I noticed that both have in common a function
> that is supposed to print and stop at fatal errors. They're
> extent_io_tree_panic (extent_io.c) and backref_tree_panic
> (relocation.c). Both call btrfs_panic which is a macro:
> 
> 3239 #define btrfs_panic(fs_info, errno, fmt, args...)                       \
> 3240 do {                                                                    \
> 3241         __btrfs_panic(fs_info, __func__, __LINE__, errno, fmt, ##args); \
> 3242         BUG();                                                          \
> 3243 } while (0)
> 
> There are no conditionals and BUG has the __noreturn annotation
> (unreachable()) so all is in place and I don't have better ideas what's
> causing the reports.

I think KCSAN is somehow disabling GCC's detection of implicit noreturn
functions -- or at least some calls to them.  So GCC is inserting dead
code after the calls.  BUG() uses __builtin_unreachable(), so GCC should
know better.

If this is specific to KCSAN then I might just disable these warnings
for KCSAN configs.

-- 
Josh